module.exports = {

    'exists': function(check) {
        return check('greedy.c exists')
        .exists('greedy.c');
    },

    'compiles': ['exists', function(check) {
        return check('greedy.c compiles')
        .run('clang -o greedy greedy.c -lcs50 -lm')
        .exit(0);
    }],

    'input 0.41, output 4': ['compiles', function(check) {
        return check('input of 0.41 yields output of 4')
        .run('clang -o greedy greedy.c -lcs50 -lm')
        .exit(0)
        .run('./greedy')
        .stdout()
        .stdin('0.41\n')
        .stdout(/4\n/)
        .exit(0);
    }],

    'input 0.01, output 1': ['compiles', function(check) {
        return check('input of 0.01 yields output of 1')
        .run('clang -o greedy greedy.c -lcs50 -lm')
        .exit(0)
        .run('./greedy')
        .stdout()
        .stdin('0.01\n')
        .stdout(/1\n/)
        .exit(0);
    }],

    'input 0.15, output 2': ['compiles', function(check) {
        return check('input of 0.15 yields output of 2')
        .run('clang -o greedy greedy.c -lcs50 -lm')
        .exit(0)
        .run('./greedy')
        .stdout()
        .stdin('0.15\n')
        .stdout(/2\n/)
        .exit(0);
    }],

    'input 1.6, output 7': ['compiles', function(check) {
        return check('input of 1.6 yields output of 7')
        .run('clang -o greedy greedy.c -lcs50 -lm')
        .exit(0)
        .run('./greedy')
        .stdout()
        .stdin('1.6\n')
        .stdout(/7\n/)
        .exit(0);
    }],

    'input 23, output 92': ['compiles', function(check) {
        return check('input of 23 yields output of 92')
        .run('clang -o greedy greedy.c -lcs50 -lm')
        .exit(0)
        .run('./greedy')
        .stdout()
        .stdin('23\n')
        .stdout(/92\n/)
        .exit(0);
    }],

    'input 4.2, output 18': ['compiles', function(check) {
        return check('input of 4.2 yields output of 18')
        .run('clang -o greedy greedy.c -lcs50 -lm')
        .exit(0)
        .run('./greedy')
        .stdout()
        .stdin('4.2\n')
        .stdout(/18\n/)
        .exit(0);
    }],

    'rejects -.1': ['compiles', function(check) {
        return check('rejects a negative input like -.1')
        .run('clang -o greedy greedy.c -lcs50 -lm')
        .exit(0)
        .run('./greedy')
        .stdout()
        .stdin('-.1\n')
        .stdout()
        .stdin();
    }],

    'rejects "foo"': ['compiles', function(check) {
        return check('rejects a non-numeric input of "foo"')
        .run('clang -o greedy greedy.c -lcs50 -lm')
        .exit(0)
        .run('./greedy')
        .stdout()
        .stdin('foo\n')
        .stdout()
        .stdin();
    }],

    'rejects ""': ['compiles', function(check) {
        return check('rejects a non-numeric input of ""')
        .run('clang -o greedy greedy.c -lcs50 -lm')
        .exit(0)
        .run('./greedy')
        .stdout()
        .stdin('\n')
        .stdout()
        .stdin();
    }]

};
